Bug 18420: Fix HoldFulfillmentPolicy.t and Passwordrecovery.t
[koha.git] / debian / scripts / koha-plack
blob5e1fc9cf65534628514f1b37db7192af7076c26d
1 #!/bin/bash
3 # Copyright 2015 Theke Solutions
5 # This file is part of Koha.
7 # This program is free software: you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation, either version 3 of the License, or
10 # (at your option) any later version.
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 # GNU General Public License for more details.
17 # You should have received a copy of the GNU General Public License
18 # along with this program. If not, see <http://www.gnu.org/licenses/>.
20 set -e
22 . /lib/lsb/init-functions
24 # Read configuration variable file if it is present
25 [ -r /etc/default/koha-common ] && . /etc/default/koha-common
27 # include helper functions
28 if [ -f "/usr/share/koha/bin/koha-functions.sh" ]; then
29 . "/usr/share/koha/bin/koha-functions.sh"
30 else
31 echo "Error: /usr/share/koha/bin/koha-functions.sh not present." 1>&2
32 exit 1
35 usage()
37 local scriptname=$(basename $0)
39 cat <<EOF
40 $scriptname
42 This script lets you manage the plack daemons for your Koha instances.
44 Usage:
45 $scriptname --start|--stop|--restart [--quiet|-q] instancename1 [instancename2...]
46 $scriptname --enable|--disable instancename1 [instancename2]
47 $scriptname -h|--help
49 --start Start the plack daemon for the specified instances
50 --stop Stop the plack daemon for the specified instances
51 --restart Restart the plack daemon for the specified instances
52 --enable Enable plack for the specified instances
53 --disable Disable plack for the specified instances
54 --quiet|-q Make the script quiet about non existent instance names
55 (useful for calling from another scripts).
56 --help|-h Display this help message
58 EOF
61 start_plack()
63 local instancename=$1
65 local PIDFILE="/var/run/koha/${instancename}/plack.pid"
66 local PLACKSOCKET="/var/run/koha/${instancename}/plack.sock"
67 local PSGIFILE="/etc/koha/plack.psgi"
68 local NAME="${instancename}-koha-plack"
70 if [ -e "/etc/koha/sites/${instancename}/plack.psgi" ]; then
71 # pick instance-specific psgi file
72 PSGIFILE="/etc/koha/sites/${instancename}/plack.psgi"
73 fi # else stick with the default one
75 _check_and_fix_perms $instancename
77 PLACK_MAX_REQUESTS=$(run_safe_xmlstarlet $instancename plack_max_requests)
78 [ -z $PLACK_MAX_REQUESTS ] && PLACK_MAX_REQUESTS="50"
79 PLACK_WORKERS=$(run_safe_xmlstarlet $instancename plack_workers)
80 [ -z $PLACK_WORKERS ] && PLACK_WORKERS="2"
82 STARMANOPTS="-M FindBin --max-requests ${PLACK_MAX_REQUESTS} --workers ${PLACK_WORKERS} \
83 --user=${instancename}-koha --group ${instancename}-koha \
84 --pid ${PIDFILE} \
85 --daemonize \
86 --access-log /var/log/koha/${instancename}/plack.log \
87 --error-log /var/log/koha/${instancename}/plack-error.log \
88 -E deployment --socket ${PLACKSOCKET} ${PSGIFILE}"
90 if ! is_plack_running ${instancename}; then
91 export KOHA_CONF="/etc/koha/sites/${instancename}/koha-conf.xml"
93 log_daemon_msg "Starting Plack daemon for ${instancename}"
95 if ${STARMAN} ${STARMANOPTS}; then
96 log_end_msg 0
97 else
98 log_end_msg 1
100 else
101 log_daemon_msg "Error: Plack already running for ${instancename}"
102 log_end_msg 1
106 stop_plack()
108 local instancename=$1
110 local PIDFILE="/var/run/koha/${instancename}/plack.pid"
112 if is_plack_running ${instancename}; then
114 log_daemon_msg "Stopping Plack daemon for ${instancename}"
116 if start-stop-daemon --pidfile ${PIDFILE} --stop --retry=TERM/30/KILL/5; then
117 log_end_msg 0
118 else
119 log_end_msg 1
121 else
122 log_daemon_msg "Error: Plack not running for ${instancename}"
123 log_end_msg 1
127 restart_plack()
129 local instancename=$1
131 local PIDFILE="/var/run/koha/${instancename}/plack.pid"
133 if is_plack_running ${instancename}; then
135 log_daemon_msg "Restarting Plack daemon for ${instancename}"
137 if stop_plack $instancename && start_plack $instancename; then
138 log_end_msg 0
139 else
140 log_end_msg 1
142 else
143 log_daemon_msg "Error: Plack not running for ${instancename}"
144 log_end_msg 1
148 enable_plack()
150 local instancename=$1
151 local instancefile=$(get_apache_config_for "$instancename")
153 if ! is_plack_enabled $instancename; then
154 # Uncomment the plack related lines for OPAC and intranet
155 sed -i 's:^\s*#\(\s*Include /etc/koha/apache-shared-opac-plack.conf\)$:\1:' "$instancefile"
156 sed -i 's:^\s*#\(\s*Include /etc/koha/apache-shared-intranet-plack.conf\)$:\1:' "$instancefile"
157 [ "${quiet}" != "yes" ] && warn "Plack enabled for ${instancename}"
158 return 0
159 else
160 [ "${quiet}" != "yes" ] && warn "Plack already enabled for ${instancename}"
161 return 1
165 disable_plack()
167 local instancename=$1
168 local instancefile=$(get_apache_config_for "$instancename")
170 if is_plack_enabled $instancename; then
171 # Comment out the plack related lines for OPAC and intranet
172 sed -i 's:^\(\s*Include /etc/koha/apache-shared-opac-plack.conf\)$:#\1:' "$instancefile"
173 sed -i 's:^\(\s*Include /etc/koha/apache-shared-intranet-plack.conf\)$:#\1:' "$instancefile"
174 [ "${quiet}" != "yes" ] && warn "Plack disabled for ${instancename}"
175 return 0
176 else
177 [ "${quiet}" != "yes" ] && warn "Plack already disabled for ${instancename}"
178 return 1
182 check_env_and_warn()
184 local apache_version_ok="no"
185 local required_modules="headers proxy_http"
186 local missing_modules=""
188 if /usr/sbin/apache2ctl -v | grep -q "Server version: Apache/2.4"; then
189 apache_version_ok="yes"
192 for module in ${required_modules}; do
193 if ! /usr/sbin/apachectl -M 2> /dev/null | grep -q ${module}; then
194 missing_modules="${missing_modules}${module} "
196 done
198 if [ "${apache_version_ok}" != "yes" ]; then
199 warn "WARNING: koha-plack requires Apache 2.4.x and you don't have that."
202 if [ "${missing_modules}" != "" ]; then
203 cat 1>&2 <<EOM
204 WARNING: koha-plack requires some Apache modules that you are missing.
205 You can install them with:
207 sudo a2enmod ${missing_modules}
214 _check_and_fix_perms()
216 local instance=$1
218 local files="/var/log/koha/${instance}/plack.log \
219 /var/log/koha/${instance}/plack-error.log"
221 for file in ${files}
223 if [ ! -e "${file}" ]; then
224 touch ${file}
226 chown "${instance}-koha":"${instance}-koha" ${file}
227 done
230 set_action()
232 if [ "$op" = "" ]; then
233 op=$1
234 else
235 die "Error: only one action can be specified."
239 STARMAN=$(which starman)
240 op=""
241 quiet="no"
243 # Read command line parameters
244 while [ $# -gt 0 ]; do
246 case "$1" in
247 -h|--help)
248 usage ; exit 0 ;;
249 -q|--quiet)
250 quiet="yes"
251 shift ;;
252 --start)
253 set_action "start"
254 shift ;;
255 --stop)
256 set_action "stop"
257 shift ;;
258 --restart)
259 set_action "restart"
260 shift ;;
261 --enable)
262 set_action "enable"
263 shift ;;
264 --disable)
265 set_action "disable"
266 shift ;;
268 die "Error: invalid option switch ($1)" ;;
270 # We expect the remaining stuff are the instance names
271 break ;;
272 esac
274 done
276 [ "${quiet}" != "yes" ] && check_env_and_warn
278 if [ $# -gt 0 ]; then
279 # We have at least one instance name
280 for name in "$@"; do
282 if is_instance $name; then
284 adjust_paths_dev_install $name
285 export DEV_INSTALL KOHA_HOME PERL5LIB=$PERL5LIB:$KOHA_HOME/installer:$KOHA_HOME/lib/installer
287 case $op in
288 "start")
289 start_plack $name
291 "stop")
292 stop_plack $name
294 "restart")
295 restart_plack $name
297 "enable")
298 enable_plack $name
300 "disable")
301 disable_plack $name
304 usage
306 esac
308 else
309 if [ "$quiet" = "no" ]; then
310 log_daemon_msg "Error: Invalid instance name $name"
311 log_end_msg 1
315 done
316 else
317 if [ "$quiet" = "no" ]; then
318 warn "Error: you must provide at least one instance name"
322 exit 0